
// Filename: common.hpp
// Author:   Nick Dingle & Will Knottenbelt {njd200,wjk}@doc.ic.ac.uk
// Date :    18th September 2002
// Notes:    Common definitions used in HYDRA sourcecode

#ifndef _COMMON_HPP
#define _COMMON_HPP
#define VERSION "0.9 (Linux)"
#define DATE "18 September 2003"
#define COPYRIGHT "(C) 2003 Nicholas J Dingle & William J Knottenbelt, Imperial College London"
#define EMAIL "{njd200,wjk}@doc.ic.ac.uk"
#define RELEASE
//#define NO_TIMER
//#define RESOURCE_USAGE
#define SRAND48
//#define EXPERIMENT
//#define SAFE

//#define STATE_COUNT

//#define real double
#define _real_ double
#define _complex_ complex<double>
#define EPS 2.22045E-16
#define LONG_EPS 1.92593E-34
#define EPS_STR "2.22045E-16"
#define SECONDARY 4294967295UL 
#define _UNDEFINED_ -1
#define CRT_WIDTH 80
#define MAX_LENGTH 512 
#define END_OF_FILE 127 
#define BUFFER_SIZE 131072

#define MEAN 1
#define VARIANCE 2
#define STDDEV 4
#define DISTRIBUTION 8

#define LARGE_NORM 1
#define RANGE_VIOLATION 2
#define SUM_VIOLATION 4
#define MY_NAN 8

#define NO_REFINE 0
#define REFINE 1

enum SolutionMethod {GAUSS, LU, GRASSMANN, POWER, GAUSS_SEIDEL, SOR, CGNR, CGS, BICG, BICGSTAB, BICGSTAB2, MYCG, AI, AIR, AUTOMATIC};
enum ReportStyle {NONE, BRIEF, FULL};
enum TransType {INSTANTANEOUS, TIMED};
enum MatrixType {UNKNOWN, COLUMN, ROW_COLUMN, DIRECT};

#endif




